# SourcePath: ncurses/20130329dev
Summary: A CRT screen handling and optimization package.
Name: sony-target-dev-ncurses
%define pkgname %{sony_tool_triplet}-%{sony_target_dialect}-dev-ncurses
Version: 5.9
Release: 12000001
URL: http://www.gnu.org/software/ncurses
Source: ncurses-%{version}.tar.gz

# LOT scripts
Source10: sony-ncurses-libopt-build-libform
Source11: sony-ncurses-libopt-build-libmenu
Source12: sony-ncurses-libopt-build-libncurses
Source13: sony-ncurses-libopt-build-libpanel
Patch1: ncurses_%{version}-pic.diff
License: MIT
Distribution: %{sony_distribution}
Vendor: %{sony_vendor}
Packager: %{sony_packager}
Group: %{sony_group}
BuildRoot: %{_tmppath}/%{name}-root
Prefix: %{sony_target_dir}
%define _docdir	%{sony_target_dir}%{sony_target_dev_doc_dir}

%description
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4BSD classic curses library.

Ncurses also contains libtermcap functionality and should be linked
into programs instead of libtermcap.

%package -n %{pkgname}
Summary: A CRT screen handling and optimization package.
Group: %{sony_group}
AutoReqProv: no

%description -n %{pkgname}
The curses library routines are a terminal-independent method of
updating character screens with reasonable optimization.  The ncurses
(new curses) library is a freely distributable replacement for the
discontinued 4.4BSD classic curses library.

Ncurses also contains libtermcap functionality and should be linked
into programs instead of libtermcap.

%prep
%setup -q -n ncurses-%{version}
%patch1 -p1

%build
# We build a full version for the host... easy way to get a runable tic
mkdir HOSTOBJDIR
cd HOSTOBJDIR
../configure --disable-shared --without-cxx --without-cxx-binding \
	--without-ada --without-curses-h --disable-termcap CFLAGS="-ffunction-sections -O2 -g" | tee ../build.log
make | tee -a ../build.log
cd ..

%sony_target_dev_setup
%demangle_XXX_config
%sony_target_dev_configure \
	--with-install-prefix=%{buildroot}%{sony_target_dir} \
	--without-ada \
	--with-profile \
	--with-shared \
	--disable-rpath --enable-echo --enable-overwrite \
	--disable-termcap \
	--with-terminfo-dirs="%{sony_target_dev_lib_dir}/terminfo:%{sony_target_dev_data_dir}/terminfo" \
	| tee -a ../build.log

make HOSTCC=gcc | tee -a ../build.log

%install
rm -rf %{buildroot}
%sony_target_dev_setup
cd %{sony_objdir}
export PATH=`pwd`/../HOSTOBJDIR/progs:$PATH
make GZIP='-9' install | tee -a ../build.log

cp lib/*_pic.a %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/.

### gzip -9 %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}/man1/tack.1

for i in `find %{buildroot}%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo -type f | sed -e s,%{buildroot},,`; do
 case "$i" in \
 */ansi | \
 */dumb | \
 */linux | \
 */rxvt | \
 */screen | */screen-w | \
 */sun | \
 */vt100 | */vt102 | */vt220 | */vt52 | \
 */xterm | */xterm-color | */xterm-r5 | */xterm-r6 | */xterm-vt220 | \
 */xterm-xfree86) echo "%attr(0644,root,root) $i" >> ncurses-base.filelist;; \
 *) echo "%attr(0644,root,root) $i" >> ncurses-term.filelist;; \
 esac
done

rm -rf %{buildroot}%{sony_target_dir}%{sony_target_dev_man_dir}


# Begin for LOT

# Set Library Optimizer variables
%define _optdir %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo
%define _libdir %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}

# Install Library Optimizer information (libform)
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libform
install -m 755 %{SOURCE10} %{_optdir}/libform/build
for i in $(ar t lib/libform.a) ; do
        install -m 644 obj_s/$i %{_optdir}/libform/
done
(cd %{_optdir}/libform; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_libdir}/libform.so -o *.o > index)
(umask 022; echo "/usr/lib/libform.so.5" > %{_optdir}/libform/path)


# Install Library Optimizer information (libmenu)
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libmenu
install -m 755 %{SOURCE11} %{_optdir}/libmenu/build
for i in $(ar t lib/libform.a) ; do
        install -m 644 obj_s/$i %{_optdir}/libmenu/
done
(cd %{_optdir}/libmenu; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_libdir}/libmenu.so -o *.o > index)
(umask 022; echo "/usr/lib/libmenu.so.5" > %{_optdir}/libmenu/path)

# Install Library Optimizer information (libncurses)
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libncurses
install -m 755 %{SOURCE12} %{_optdir}/libncurses/build
for i in $(ar t lib/libncurses.a) ; do
        install -m 644 obj_s/$i %{_optdir}/libncurses/
done
(cd %{_optdir}/libncurses; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_libdir}/libncurses.so -o *.o > index)
(umask 022; echo "/usr/lib/libncurses.so.5" > %{_optdir}/libncurses/path)


# Install Library Optimizer information (libpanel)
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/libpanel
install -m 755 %{SOURCE13} %{_optdir}/libpanel/build
for i in $(ar t lib/libpanel.a) ; do
        install -m 644 obj_s/$i %{_optdir}/libpanel/
done
(cd %{_optdir}/libpanel; umask 022; %{sony_cross_bin_dir}/%{sony_tool_triplet}-libindex %{_libdir}/libpanel.so -o *.o > index)
(umask 022; echo "/usr/lib/libpanel.so.5" > %{_optdir}/libpanel/path)


# for 6.x
mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_bin_dir}/*-config \
	%{buildroot}%{sony_target_dir}%{sony_target_devtool_bin_dir}

mkdir -p %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}
mv %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/*.a \
	%{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}

for l in `ls %{buildroot}%{sony_target_dir}%{sony_target_devtool_lib_dir}`; do
   if [ "$l" != "optinfo" ]; then
      ln -s ../..%{sony_target_devtool_lib_dir}/$l \
	 %{buildroot}%{sony_target_dir}%{sony_target_dev_lib_dir}/$l
  fi
 done

%clean
rm -rf %{buildroot}

%files -n %{pkgname}
%defattr(-,root,root,-)
%{sony_target_dir}%{sony_target_dev_bin_dir}/captoinfo
%{sony_target_dir}%{sony_target_dev_bin_dir}/clear
%{sony_target_dir}%{sony_target_dev_bin_dir}/infocmp
%{sony_target_dir}%{sony_target_dev_bin_dir}/infotocap
%{sony_target_dir}%{sony_target_dev_bin_dir}/reset
#%{sony_target_dir}%{sony_target_dev_bin_dir}/tack
%{sony_target_dir}%{sony_target_dev_bin_dir}/tic
%{sony_target_dir}%{sony_target_dev_bin_dir}/toe
%{sony_target_dir}%{sony_target_dev_bin_dir}/tput
%{sony_target_dir}%{sony_target_dev_bin_dir}/tset
%{sony_target_dir}%{sony_target_devtool_bin_dir}/ncurses5-config
%{sony_target_dir}%{sony_target_dev_include_dir}/curses.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursesapp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursesf.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursesm.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursesp.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursesw.h
%{sony_target_dir}%{sony_target_dev_include_dir}/cursslk.h
%{sony_target_dir}%{sony_target_dev_include_dir}/eti.h
%{sony_target_dir}%{sony_target_dev_include_dir}/etip.h
%{sony_target_dir}%{sony_target_dev_include_dir}/form.h
%{sony_target_dir}%{sony_target_dev_include_dir}/menu.h
%{sony_target_dir}%{sony_target_dev_include_dir}/ncurses.h
%{sony_target_dir}%{sony_target_dev_include_dir}/ncurses_dll.h
%{sony_target_dir}%{sony_target_dev_include_dir}/panel.h
%{sony_target_dir}%{sony_target_dev_include_dir}/term.h
%{sony_target_dir}%{sony_target_dev_include_dir}/termcap.h
%{sony_target_dir}%{sony_target_dev_include_dir}/unctrl.h
%{sony_target_dir}%{sony_target_dev_include_dir}/nc_tparm.h
%{sony_target_dir}%{sony_target_dev_include_dir}/term_entry.h
%{sony_target_dir}%{sony_target_dev_include_dir}/tic.h

%{sony_target_dir}%{sony_target_dev_lib_dir}/libcurses.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libcurses.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform.so.5
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform.so.5.9
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform_g.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform_p.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libform_pic.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu.so.5
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu.so.5.9
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu_g.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu_p.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libmenu_pic.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses++.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses.so.5
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses.so.5.9
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses_g.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses_p.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libncurses_pic.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel.so
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel.so.5
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel.so.5.9
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel_g.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel_p.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/libpanel_pic.a
%{sony_target_dir}%{sony_target_dev_lib_dir}/terminfo
%{sony_target_dir}%{sony_target_dev_data_dir}/tabset/std
%{sony_target_dir}%{sony_target_dev_data_dir}/tabset/stdcrt
%{sony_target_dir}%{sony_target_dev_data_dir}/tabset/vt100
%{sony_target_dir}%{sony_target_dev_data_dir}/tabset/vt300
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/1/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/2/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/3/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/4/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/5/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/6/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/7/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/8/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/9/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/A/*
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/A/Apple_Terminal-ascii
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/A/Apple_Terminal-ascii-m
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/A/Apple_Terminal-m
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/E/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/L/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/M/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/N/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/P/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/Q/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/X/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/a/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/b/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/c/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/d/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/e/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/f/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/g/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/h/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/i/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/j/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/k/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/l/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/m/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/n/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/o/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/p/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/q/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/r/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/s/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/t/*
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/t/tvi-2p
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/t/tvi912-2p
##%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/t/tvi920-2p
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/u/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/v/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/w/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/x/*
%{sony_target_dir}%{sony_target_dev_data_dir}/terminfo/z/*

%{sony_target_dir}%{sony_target_devtool_lib_dir}/lib*.a

%{sony_target_dir}%{sony_target_dev_bin_dir}/tabs

# for LOT
%{sony_target_dir}%{sony_target_devtool_lib_dir}/optinfo/*


%changelog
* Thu May 05 2016 Sony Corporation
- Added armhf support in LOT build script

* Mon Aug 12 2013 Sony Corporation
- Changed License information.

* Fri Mar 29 2013 Sony Corporation
- Version update to 5.9.

* Thu Apr 30 2009 Sony Corporation
- Remove hhl-libopt-build-ncurses which is not needed.

* Wed Apr 22 2009 Sony Corporation
- Updated to 6.x

* Tue Jun 10 2008 Sony Corporation
- add $CROSS_COMPILE_PREFIX in ncurses-config

* Tue Mar 06 2007 Sony Corporation
- Version update to 5.6

* Tue Jan 18 2005 Sony Corporation
- modify --with-terminfo-dirs

* Wed Nov 17 2004 Sony Corporation
- delete online manual

* Fri Aug 27 2004 Sony Corporation - 5.2-1
- Conformed to 20040825-rule
- remove unnecessary source (.tmpl files)

* Tue Aug  3 2004 Sony Corporation - dev-ncurses
- Initial build.

